; Name:         div.nasm
; Assemblieren: nasm.exe div.nasm
; Linken:       a) GoLink.exe div.obj /console /entry _main /fo div-nasm-msvcrt.exe msvcrt.dll
;               b) GoLink.exe div.obj /console /entry _main /fo div-nasm-crtdll.exe crtdll.dll

BITS 32

SEGMENT .data
    Dividend: dd 3979415386
    Divisor:  dd 100000
	fmt:	  db "%u div %u = %u",10,0

SEGMENT .bss
    Quotient resd 1

EXTERN printf
SEGMENT .text
GLOBAL _main
_main:                                 ; EDI = EAX / EBX
        mov eax, dword [Dividend]
        mov ebx, dword [Divisor]
        xor edi, edi                   ; Quotient = 0 (Anfangswert)
        xor edx, edx                   ; Zahl (dl) = 0 (Anfangswert)
        mov cl, 32                     ; 32 Schleifendurchgnge: for (CL=32; CL>0; CL--)
    Schleife:
        shl eax, 1                     ; Bit 31 von EAX ...
        rcl edx, 1                     ;     ... nach Bit 1 von EDX
        cmp ebx, edx                   ;  Carry gesetzt, wenn EDX > Divisor (Fall Wei)
        ja Sprungmarke                 ; Sprung, wenn Carry=0 und Zero=0 (Ergebnis nicht Null)
        sub edx, ebx                   ; Fall Wei: EDX = EDX - EBX
        stc                            ; Carry setzen
    Sprungmarke:
        rcl edi, 1                     ; Carry (0 oder 1) an Quotienten kleben.
        sub cl, 1
        jnz Schleife
        mov dword [Quotient], edi
        
		push    dword [Quotient]
		push    dword [Divisor]
		push    dword [Dividend]
		push    fmt
		call    printf                  ; msvcrt.dll
		add     esp,16                  ; cdecl

        mov eax, 0                      ; Exitcode
        ret
